



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python学习札记(三十六) 面向对象编程 Object Oriented Program 7 __slots__</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python学习札记(三十六) 面向对象编程 Object Oriented Program 7 __slots__</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 01:54:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>参考：<a href="http://www.liaoxuefeng.com/wiki/0014316089557264a6b348958f449949df42a6d3a2e542c000/00143186739713011a09b63dcbd42cc87f907a778b3ac73000" rel="external nofollow noreferrer"><strong>slots</strong></a></h2>
<h2>NOTE</h2>
<p>1.动态语言灵活绑定属性及方法。</p>
<pre class="prettyprint linenums"><code>#!/usr/bin/env python3

class MyClass(object):<br />
	def __init__(self):<br />
		pass

def func(obj):<br />
	print(obj.name, obj.age)

def main():<br />
	h = MyClass()<br />
	h.name = 'Chen'<br />
	h.age = '20'<br />
	func(h)

if __name__ == '__main__':<br />
	main()<br />
</code></pre>
<p>给对象h绑定了属性name和age。</p>
<pre class="prettyprint linenums"><code>sh-3.2# ./oop7.py<br />
Chen 20<br />
</code></pre>
<p>绑定一个新的方法：</p>
<pre class="prettyprint linenums"><code>from types import MethodType

def f(self):<br />
	print('I\'m new here!')

h.f = MethodType(f, h) # new method<br />
h.f()<br />
</code></pre>
<pre class="prettyprint linenums"><code>I'm new here!<br />
</code></pre>
<p>但是这种绑定的方法并不存在于新建的对象：</p>
<pre class="prettyprint linenums"><code>	h1 = MyClass()<br />
	h1.f()<br />
</code></pre>
<pre class="prettyprint linenums"><code>Traceback (most recent call last):<br />
  File &quot;./oop7.py&quot;, line 28, in &lt;module&gt;<br />
    main()<br />
  File &quot;./oop7.py&quot;, line 25, in main<br />
    h1.f()<br />
AttributeError: 'MyClass' object has no attribute 'f'<br />
</code></pre>
<p>给类绑定一个方法，解决这个问题：</p>
<pre class="prettyprint linenums"><code>	MyClass.f = f

	h1 = MyClass()<br />
	h1.f()<br />
</code></pre>
<pre class="prettyprint linenums"><code>I'm new here!<br />
</code></pre>
<p>通常情况下，上面的f方法可以直接定义在class中，但动态绑定允许我们在程序运行的过程中动态给class加上功能，这在静态语言中很难实现。</p>
<p>2.<code>__slots__</code></p>
<p>但是，如果我们想要限制实例的属性怎么办？比如，只允许对MyClass实例添加name和age属性。</p>
<p>为了达到限制的目的，Python允许在定义class的时候，定义一个特殊的<code>__slots__</code>变量，来限制该class实例能添加的属性：</p>
<pre class="prettyprint linenums"><code>#!/usr/bin/env python3

class MyClass(object):<br />
	&quot;&quot;&quot;docstring for MyClass&quot;&quot;&quot;<br />
	__slots__ = ('name', 'age')<br />
	def __init__(self):<br />
		super(MyClass, self).__init__()<br />
		pass

def main():<br />
	h = MyClass()<br />
	h.name = 'Chen'<br />
	h.age = 20<br />
	h.city = 'FuZhou'

if __name__ == '__main__':<br />
	main()<br />
</code></pre>
<pre class="prettyprint linenums"><code>sh-3.2# ./oop8.py<br />
Traceback (most recent call last):<br />
  File &quot;./oop8.py&quot;, line 17, in &lt;module&gt;<br />
    main()<br />
  File &quot;./oop8.py&quot;, line 14, in main<br />
    h.city = 'FuZhou'<br />
AttributeError: 'MyClass' object has no attribute 'city'<br />
</code></pre>
<p><code>__slots__</code>用tuple定义允许绑定的属性名称，由于'city'没有被放到__slots__中，所以不能绑定city属性。</p>
<p><strong>使用<code>__slots__</code>要注意，<code>__slots__</code>定义的属性仅对当前类实例起作用，对继承的子类是不起作用的：</strong></p>
<pre class="prettyprint linenums"><code>#!/usr/bin/env python3

class MyClass(object):<br />
	&quot;&quot;&quot;docstring for MyClass&quot;&quot;&quot;<br />
	__slots__ = ('name', 'age')<br />
	def __init__(self):<br />
		super(MyClass, self).__init__()<br />
		pass

class Student(MyClass):<br />
	&quot;&quot;&quot;docstring for Student&quot;&quot;&quot;<br />
	def __init__(self):<br />
		super(Student, self).__init__()<br />
		pass

def main():<br />
	h = MyClass()<br />
	h.name = 'Chen'<br />
	h.age = 20<br />
	# h.city = 'FuZhou'

	h1 = Student()<br />
	h1.name = 'Chen'<br />
	h1.age = 20<br />
	h1.city = 'FuZhou'

	print(h1.name, h1.age, h1.city)

if __name__ == '__main__':<br />
	main()<br />
</code></pre>
<pre class="prettyprint linenums"><code>sh-3.2# ./oop8.py<br />
Chen 20 FuZhou<br />
</code></pre>
<blockquote><p>2017/3/2</p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r933jwr9.html">padding与margin的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyz3p29.html">ip&lowbar;forward</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xnx4w9.html">png图片那点事</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1vx0r9.html">eclipse运行emulator时，PANIC&colon;Could not open emulator的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xl6on9.html">~&sol;&period;vimrc config</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxngzpj8.html">常见的浏览器Hack技巧总结&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn0636q.html">&lbrack;BZOJ3561&rsqb; DZY Loves Math VI</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljew109.html">Spring &lpar;一&rpar; IOC &lpar; Inversion Of Control &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pp4z48.html">RH033读书笔记&lpar;16&rpar;-Lab 17 Installation and Administration Tools</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjlwk38.html">关于The requested PHP extension ext-pdo&lowbar;sqlite &ast; is missing from your system&period; Install or enable PHP&amp;&num;39&semi;s pdo&lowbar;sqlite extension&period;的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj43n1q.html">Ddos 攻击</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpg1g7q.html">Exception in thread &quot;main&quot; org&period;hibernate&period;MappingException&colon; You may only specify a cache for root</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zwgye9.html">SMJobBless官方Demo笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rvo448.html">1&period;02-get-params</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2z1119.html">linux&colon;提取匹配含有小数点的数字（grep函数）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1p0349.html">2017&period;12&period;10《&OpenCurlyDoubleQuote;剑锋OI&rdquo;普及组多校联盟系列赛（14）&num;Sooke&num;Kornal 的课余时间 》分析报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwxr0z8.html">plink命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllv7n6q.html">2019年度【计算机视觉&amp;amp&semi;机器学习&amp;amp&semi;人工智能】国际重要会议汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwor7z8.html">ant&lowbar;&lowbar;&lowbar;&lowbar;&amp;lt&semi;project&amp;gt&semi;标签的使用与含义</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5j5mrq.html">深入理解Spring的ImportSelector接口</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qvep6xo9.html">【Android N 7&period;1&period;1】 ActivityManagerService 获取cpu状态</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pr5vw8.html">hihocoder &lbrack;Offer收割&rsqb;编程练习赛14&Tab;剑刃风暴</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1voe60q.html">shell 中的（）【】&lbrace;&rcub;（（））</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvne3gq.html">Intellij IDEA同时打开多个项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql10mk09.html">Linux（Centos）下搭建SVN服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlyv1r9.html">Andrew Ng机器学习公开课笔记 -- Generative Learning algorithms</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e1ewe9.html">棋盘游戏---hdu1281（最大匹配）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pp5me79.html">Nginx反向代理服务器安装与配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pp5k049.html">基于Python的交互式可视化工具 &lbrack;转&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj4wyp8.html">JDBC连接数据库（一）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
